Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 1200)
@@ -338,21 +520,7 @@
   5   //  64x64   33
 };
-#endif // FAST_UDI_USE_MPM
-
-// chroma
-
-const UChar g_aucConvertTxtTypeToIdx[4] = { 0, 1, 1, 2 };
-
-
-// ====================================================================================================================
-// Bit-depth
-// ====================================================================================================================
-
-Int  g_bitDepthY = 8;
-Int  g_bitDepthC = 8;
-
-UInt g_uiPCMBitDepthLuma     = 8;    // PCM bit-depth
-UInt g_uiPCMBitDepthChroma   = 8;    // PCM bit-depth
-
+const UChar g_chroma422IntraAngleMappingTable[NUM_INTRA_MODE] =
+  //0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, DM
+  { 0, 1, 2, 2, 2, 2, 3, 5, 7, 8, 10, 12, 13, 15, 17, 18, 19, 20, 21, 22, 23, 23, 24, 24, 25, 25, 26, 27, 27, 28, 28, 29, 29, 30, 31, DM_CHROMA_IDX};
 #if H_3D_DIM_DMM
 // ====================================================================================================================
@@ -368,30 +536,24 @@
   FULL_PEL     // 128x128
 };
-
 const UChar g_dmm1TabIdxBits[6] =
 { //2x2   4x4   8x8 16x16 32x32 64x64
      0,    7,   10,   9,    9,   13 };
-
 const UChar g_dmm3IntraTabIdxBits[6] =
 { //2x2   4x4   8x8 16x16 32x32 64x64
      0,    4,    7,    8,    8,    0 };
-
 Bool g_wedgePattern[32*32];
-
 extern std::vector< std::vector<TComWedgelet> >   g_dmmWedgeLists;
 extern std::vector< std::vector<TComWedgeRef> >   g_dmmWedgeRefLists;
 extern std::vector< std::vector<TComWedgeNode> >  g_dmmWedgeNodeLists;
 #endif
-
 // ====================================================================================================================
 // Misc.
 // ====================================================================================================================
-
 Char  g_aucConvertToBit  [ MAX_CU_SIZE+1 ];
 #if ENC_DEC_TRACE
-FILE*  g_hTrace = NULL;
+FILE*  g_hTrace = NULL; // Set to NULL to open up a file. Set to stdout to use the current output
 const Bool g_bEncDecTraceEnable  = true;
 const Bool g_bEncDecTraceDisable = false;
-Bool   g_HLSTraceEnable = true;
+Bool   g_HLSTraceEnable = false;
 Bool   g_bJustDoIt = false;
 UInt64 g_nSymbolCounter = 0;
@@ -407,8 +569,8 @@
 Bool g_decTraceMvFromMerge   = false; 
 Bool g_decTracePicOutput     = false; 
-Bool g_stopAtPos             = true; 
-Bool g_outputPos             = true;   
+Bool g_stopAtPos             = false; 
+Bool g_outputPos             = false;   
 Bool g_traceCameraParameters = false; 
-Bool g_encNumberOfWrittenBits     = true; 
+Bool g_encNumberOfWrittenBits     = false; 
 #endif
 #endif
@@ -416,148 +578,74 @@
 // Scanning order & context model mapping
 // ====================================================================================================================
-
 // scanning order table
-UInt* g_auiSigLastScan[ 3 ][ MAX_CU_DEPTH ];
-
-const UInt g_sigLastScan8x8[ 3 ][ 4 ] =
-{
-  {0, 2, 1, 3},
-  {0, 1, 2, 3},
-  {0, 2, 1, 3}
-};
-UInt g_sigLastScanCG32x32[ 64 ];
-
-const UInt g_uiMinInGroup[ 10 ] = {0,1,2,3,4,6,8,12,16,24};
-const UInt g_uiGroupIdx[ 32 ]   = {0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9};
-
-Void initSigLastScan(UInt* pBuffD, UInt* pBuffH, UInt* pBuffV, Int iWidth, Int iHeight)
-{
-  const UInt  uiNumScanPos  = UInt( iWidth * iWidth );
-  UInt        uiNextScanPos = 0;
-
-  if( iWidth < 16 )
-  {
-  UInt* pBuffTemp = pBuffD;
-  if( iWidth == 8 )
-  {
-    pBuffTemp = g_sigLastScanCG32x32;
-  }
-  for( UInt uiScanLine = 0; uiNextScanPos < uiNumScanPos; uiScanLine++ )
-  {
-    Int    iPrimDim  = Int( uiScanLine );
-    Int    iScndDim  = 0;
-    while( iPrimDim >= iWidth )
-    {
-      iScndDim++;
-      iPrimDim--;
-    }
-    while( iPrimDim >= 0 && iScndDim < iWidth )
-    {
-      pBuffTemp[ uiNextScanPos ] = iPrimDim * iWidth + iScndDim ;
-      uiNextScanPos++;
-      iScndDim++;
-      iPrimDim--;
-    }
-  }
-  }
-  if( iWidth > 4 )
-  {
-    UInt uiNumBlkSide = iWidth >> 2;
-    UInt uiNumBlks    = uiNumBlkSide * uiNumBlkSide;
-    UInt log2Blk      = g_aucConvertToBit[ uiNumBlkSide ] + 1;
-
-    for( UInt uiBlk = 0; uiBlk < uiNumBlks; uiBlk++ )
-    {
-      uiNextScanPos   = 0;
-      UInt initBlkPos = g_auiSigLastScan[ SCAN_DIAG ][ log2Blk ][ uiBlk ];
-      if( iWidth == 32 )
-      {
-        initBlkPos = g_sigLastScanCG32x32[ uiBlk ];
-      }
-      UInt offsetY    = initBlkPos / uiNumBlkSide;
-      UInt offsetX    = initBlkPos - offsetY * uiNumBlkSide;
-      UInt offsetD    = 4 * ( offsetX + offsetY * iWidth );
-      UInt offsetScan = 16 * uiBlk;
-      for( UInt uiScanLine = 0; uiNextScanPos < 16; uiScanLine++ )
-      {
-        Int    iPrimDim  = Int( uiScanLine );
-        Int    iScndDim  = 0;
-        while( iPrimDim >= 4 )
-        {
-          iScndDim++;
-          iPrimDim--;
-        }
-        while( iPrimDim >= 0 && iScndDim < 4 )
-        {
-          pBuffD[ uiNextScanPos + offsetScan ] = iPrimDim * iWidth + iScndDim + offsetD;
-          uiNextScanPos++;
-          iScndDim++;
-          iPrimDim--;
-        }
-      }
-    }
-  }
-  
-  UInt uiCnt = 0;
-  if( iWidth > 2 )
-  {
-    UInt numBlkSide = iWidth >> 2;
-    for(Int blkY=0; blkY < numBlkSide; blkY++)
-    {
-      for(Int blkX=0; blkX < numBlkSide; blkX++)
-      {
-        UInt offset    = blkY * 4 * iWidth + blkX * 4;
-        for(Int y=0; y < 4; y++)
-        {
-          for(Int x=0; x < 4; x++)
-          {
-            pBuffH[uiCnt] = y*iWidth + x + offset;
-            uiCnt ++;
-          }
-        }
-      }
-    }
-
-    uiCnt = 0;
-    for(Int blkX=0; blkX < numBlkSide; blkX++)
-    {
-      for(Int blkY=0; blkY < numBlkSide; blkY++)
-      {
-        UInt offset    = blkY * 4 * iWidth + blkX * 4;
-        for(Int x=0; x < 4; x++)
-        {
-          for(Int y=0; y < 4; y++)
-          {
-            pBuffV[uiCnt] = y*iWidth + x + offset;
-            uiCnt ++;
-          }
-        }
-      }
-    }
-  }
-  else
-  {
-  for(Int iY=0; iY < iHeight; iY++)
-  {
-    for(Int iX=0; iX < iWidth; iX++)
-    {
-      pBuffH[uiCnt] = iY*iWidth + iX;
-      uiCnt ++;
-    }
-  }
-
-  uiCnt = 0;
-  for(Int iX=0; iX < iWidth; iX++)
-  {
-    for(Int iY=0; iY < iHeight; iY++)
-    {
-      pBuffV[uiCnt] = iY*iWidth + iX;
-      uiCnt ++;
-    }
-  }    
-  }
-}
-
-Int g_quantTSDefault4x4[16] =
+UInt* g_scanOrder[SCAN_NUMBER_OF_GROUP_TYPES][SCAN_NUMBER_OF_TYPES][ MAX_CU_DEPTH ][ MAX_CU_DEPTH ];
+const UInt ctxIndMap4x4[4*4] =
+{
+  0, 1, 4, 5,
+  2, 3, 4, 5,
+  6, 6, 8, 8,
+  7, 7, 8, 8
+};
+const UInt g_uiMinInGroup[ LAST_SIGNIFICANT_GROUPS ] = {0,1,2,3,4,6,8,12,16,24};
+const UInt g_uiGroupIdx[ MAX_TU_SIZE ]   = {0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9};
+const Char *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
+{
+  {
+    "INTRA4X4_LUMA",
+    "INTRA4X4_CHROMAU",
+    "INTRA4X4_CHROMAV",
+    "INTER4X4_LUMA",
+    "INTER4X4_CHROMAU",
+    "INTER4X4_CHROMAV"
+  },
+  {
+    "INTRA8X8_LUMA",
+    "INTRA8X8_CHROMAU",
+    "INTRA8X8_CHROMAV",
+    "INTER8X8_LUMA",
+    "INTER8X8_CHROMAU",
+    "INTER8X8_CHROMAV"
+  },
+  {
+    "INTRA16X16_LUMA",
+    "INTRA16X16_CHROMAU",
+    "INTRA16X16_CHROMAV",
+    "INTER16X16_LUMA",
+    "INTER16X16_CHROMAU",
+    "INTER16X16_CHROMAV"
+  },
+  {
+   "INTRA32X32_LUMA",
+   "INTRA32X32_CHROMAU_FROM16x16_CHROMAU",
+   "INTRA32X32_CHROMAV_FROM16x16_CHROMAV",
+   "INTER32X32_LUMA",
+   "INTER32X32_CHROMAU_FROM16x16_CHROMAU",
+   "INTER32X32_CHROMAV_FROM16x16_CHROMAV"
+  },
+};
+const Char *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
+{
+  {
+  },
+  {
+  },
+  {
+    "INTRA16X16_LUMA_DC",
+    "INTRA16X16_CHROMAU_DC",
+    "INTRA16X16_CHROMAV_DC",
+    "INTER16X16_LUMA_DC",
+    "INTER16X16_CHROMAU_DC",
+    "INTER16X16_CHROMAV_DC"
+  },
+  {
+    "INTRA32X32_LUMA_DC",
+    "INTRA32X32_CHROMAU_DC_FROM16x16_CHROMAU",
+    "INTRA32X32_CHROMAV_DC_FROM16x16_CHROMAV",
+    "INTER32X32_LUMA_DC",
+    "INTER32X32_CHROMAU_DC_FROM16x16_CHROMAU",
+    "INTER32X32_CHROMAV_DC_FROM16x16_CHROMAV"
+  },
+};
+const Int g_quantTSDefault4x4[4*4] =
 {
   16,16,16,16,
@@ -566,6 +654,5 @@
   16,16,16,16
 };
-
-Int g_quantIntraDefault8x8[64] =
+const Int g_quantIntraDefault8x8[8*8] =
 {
   16,16,16,16,17,18,21,24,
@@ -578,6 +665,5 @@
   24,25,29,36,47,65,88,115
 };
-
-Int g_quantInterDefault8x8[64] =
+const Int g_quantInterDefault8x8[8*8] =
 {
   16,16,16,16,17,18,20,24,
@@ -590,14 +676,21 @@
   24,25,28,33,41,54,71,91
 };
-UInt g_scalingListSize   [4] = {16,64,256,1024}; 
-UInt g_scalingListSizeX  [4] = { 4, 8, 16,  32};
-UInt g_scalingListNum[SCALING_LIST_SIZE_NUM]={6,6,6,2};
-Int  g_eTTable[4] = {0,3,1,2};
-
+const UInt g_scalingListSize   [SCALING_LIST_SIZE_NUM] = {16,64,256,1024};
+const UInt g_scalingListSizeX  [SCALING_LIST_SIZE_NUM] = { 4, 8, 16,  32};
 #if H_MV_ENC_DEC_TRAC
 #if ENC_DEC_TRACE
+Void tracePSHeader( const Char* psName, Int layerId )
+{  
+  if ( !g_disableHLSTrace  ) 
+  {
+    fprintf( g_hTrace, "=========== ");    
+    fprintf( g_hTrace, "%s", psName );    
+    fprintf( g_hTrace, " Layer %d ===========", layerId );    
+    fprintf( g_hTrace, "\n" );    
+    fflush ( g_hTrace );    
+  }
+}
 Void stopAtPos( Int poc, Int layerId, Int cuPelX, Int cuPelY, Int cuWidth, Int cuHeight )
 {
-
   if ( g_outputPos ) 
   {
@@ -610,5 +703,4 @@
               << std::endl; 
   }
-
   Bool stopFlag = false; 
   if ( g_stopAtPos && poc == 0 && layerId == 2 )
@@ -623,12 +715,9 @@
       Int xPos = 888; 
       Int yPos = 248; 
-
       Int cuPelXEnd = cuPelX + cuWidth  - 1; 
       Int cuPelYEnd = cuPelY + cuHeight - 1; 
-
       stopFlag = (cuPelX <= xPos ) && (cuPelXEnd >= xPos ) && (cuPelY <= yPos ) && (cuPelYEnd >= yPos ); 
     }
   }
-  
   if ( stopFlag )
   { // Set breakpoint here. 
@@ -636,5 +725,4 @@
   }  
 }
-
 Void writeToTraceFile( const Char* symbolName, Int val, Bool doIt )
 {
@@ -654,5 +742,4 @@
   }
 }
-
 Void writeToTraceFile( const Char* symbolName, Bool doIt )
 {
@@ -664,5 +751,4 @@
   }
 }
-
 #endif
 #endif
@@ -671,9 +757,7 @@
 std::vector< std::vector<TComWedgeRef>  > g_dmmWedgeRefLists;
 std::vector< std::vector<TComWedgeNode> > g_dmmWedgeNodeLists;
-
 Void initWedgeLists( Bool initNodeList )
 {
   if( !g_dmmWedgeLists.empty() ) return;
-
   for( UInt ui = g_aucConvertToBit[DIM_MIN_SIZE]; ui < (g_aucConvertToBit[DIM_MAX_SIZE]); ui++ )
   {
@@ -684,5 +768,4 @@
     g_dmmWedgeLists.push_back( acWedgeList );
     g_dmmWedgeRefLists.push_back( acWedgeRefList );
-
     if( initNodeList )
     {
@@ -695,5 +778,4 @@
           TComWedgeNode cWedgeNode;
           cWedgeNode.setPatternIdx( uiPos );
-
           UInt uiRefPos = 0;
           for( Int iOffS = -1; iOffS <= 1; iOffS++ )
@@ -702,10 +784,8 @@
             {
               if( iOffS == 0 && iOffE == 0 ) { continue; }
-
               Int iSx = (Int)acWedgeList[uiPos].getStartX();
               Int iSy = (Int)acWedgeList[uiPos].getStartY();
               Int iEx = (Int)acWedgeList[uiPos].getEndX();
               Int iEy = (Int)acWedgeList[uiPos].getEndY();
-
               switch( acWedgeList[uiPos].getOri() )
               {
@@ -718,5 +798,4 @@
               default: assert( 0 );
               }
-
               for( UInt k = 0; k < acWedgeRefList.size(); k++ )
               {
@@ -730,5 +809,4 @@
                     Bool bNew = true;
                     for( UInt m = 0; m < uiRefPos; m++ ) { if( acWedgeRefList[k].getRefIdx() == cWedgeNode.getRefineIdx( m ) ) { bNew = false; break; } }
-
                     if( bNew ) 
                     {
@@ -749,11 +827,8 @@
   }
 }
-
 Void createWedgeList( UInt uiWidth, UInt uiHeight, std::vector<TComWedgelet> &racWedgeList, std::vector<TComWedgeRef> &racWedgeRefList, WedgeResolution eWedgeRes )
 {
   assert( uiWidth == uiHeight );
-
   Int posStart = 0, posEnd = 0;
-
   UInt uiBlockSize = 0;
   switch( eWedgeRes )
@@ -762,9 +837,7 @@
   case(   HALF_PEL ): { uiBlockSize = (uiWidth<<1); break; }
   }
-
   TComWedgelet cTempWedgelet( uiWidth, uiHeight );
   for( UInt uiOri = 0; uiOri < 6; uiOri++ )
   {
-
     posEnd = (Int) racWedgeList.size();
     if (uiOri == 0 || uiOri == 4)
@@ -793,8 +866,5 @@
     posStart = posEnd;
   }
-
-
-}
-
+}
 Void addWedgeletToList( TComWedgelet cWedgelet, std::vector<TComWedgelet> &racWedgeList, std::vector<TComWedgeRef> &racWedgeRefList )
 {
@@ -838,4 +908,3 @@
 }
 #endif //H_3D_DIM_DMM
-
 //! \}
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComRom.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -31,123 +31,64 @@
  * THE POSSIBILITY OF SUCH DAMAGE.
  */
-
 /** \file     TComRom.h
     \brief    global variables & functions (header)
 */
-
 #ifndef __TCOMROM__
 #define __TCOMROM__
-
 #include "CommonDef.h"
-#include "TypeDef.h"
-
 #include<stdio.h>
 #include<iostream>
-
 #if H_3D_DIM
 #include "TComWedgelet.h"
 #endif
-
 //! \ingroup TLibCommon
 //! \{
-
-// ====================================================================================================================
-// Macros
-// ====================================================================================================================
-
-#define     MAX_CU_DEPTH            6                           // log2(LCUSize)
-#define     MAX_CU_SIZE             (1<<(MAX_CU_DEPTH))         // maximum allowable size of CU
-#define     MIN_PU_SIZE             4
-#define     MAX_NUM_SPU_W           (MAX_CU_SIZE/MIN_PU_SIZE)   // maximum number of SPU in horizontal line
-
 // ====================================================================================================================
 // Initialize / destroy functions
 // ====================================================================================================================
-
 Void         initROM();
 Void         destroyROM();
-Void         initSigLastScan(UInt* pBuffD, UInt* pBuffH, UInt* pBuffV, Int iWidth, Int iHeight);
 // ====================================================================================================================
 // Data structure related table & variable
 // ====================================================================================================================
-
 // flexible conversion from relative to absolute index
-extern       UInt   g_auiZscanToRaster[ MAX_NUM_SPU_W*MAX_NUM_SPU_W ];
-extern       UInt   g_auiRasterToZscan[ MAX_NUM_SPU_W*MAX_NUM_SPU_W ];
-
+extern       UInt   g_auiZscanToRaster[ MAX_NUM_PART_IDXS_IN_CTU_WIDTH*MAX_NUM_PART_IDXS_IN_CTU_WIDTH ];
+extern       UInt   g_auiRasterToZscan[ MAX_NUM_PART_IDXS_IN_CTU_WIDTH*MAX_NUM_PART_IDXS_IN_CTU_WIDTH ];
+extern       UInt*  g_scanOrder[SCAN_NUMBER_OF_GROUP_TYPES][SCAN_NUMBER_OF_TYPES][ MAX_CU_DEPTH ][ MAX_CU_DEPTH ];
 Void         initZscanToRaster ( Int iMaxDepth, Int iDepth, UInt uiStartVal, UInt*& rpuiCurrIdx );
 Void         initRasterToZscan ( UInt uiMaxCUWidth, UInt uiMaxCUHeight, UInt uiMaxDepth         );
-
 // conversion of partition index to picture pel position
-extern       UInt   g_auiRasterToPelX[ MAX_NUM_SPU_W*MAX_NUM_SPU_W ];
-extern       UInt   g_auiRasterToPelY[ MAX_NUM_SPU_W*MAX_NUM_SPU_W ];
-
+extern       UInt   g_auiRasterToPelX[ MAX_NUM_PART_IDXS_IN_CTU_WIDTH*MAX_NUM_PART_IDXS_IN_CTU_WIDTH ];
+extern       UInt   g_auiRasterToPelY[ MAX_NUM_PART_IDXS_IN_CTU_WIDTH*MAX_NUM_PART_IDXS_IN_CTU_WIDTH ];
 Void         initRasterToPelXY ( UInt uiMaxCUWidth, UInt uiMaxCUHeight, UInt uiMaxDepth );
-
-// global variable (LCU width/height, max. CU depth)
-extern       UInt g_uiMaxCUWidth;
-extern       UInt g_uiMaxCUHeight;
-extern       UInt g_uiMaxCUDepth;
-extern       UInt g_uiAddCUDepth;
-
-#define MAX_TS_WIDTH  4
-#define MAX_TS_HEIGHT 4
-
-extern       UInt g_auiPUOffset[8];
-
-#define QUANT_IQUANT_SHIFT    20 // Q(QP%6) * IQ(QP%6) = 2^20
-#define QUANT_SHIFT           14 // Q(4) = 2^14
-#define SCALE_BITS            15 // Inherited from TMuC, pressumably for fractional bit estimates in RDOQ
-#define MAX_TR_DYNAMIC_RANGE  15 // Maximum transform dynamic range (excluding sign bit)
-
-#define SHIFT_INV_1ST          7 // Shift after first inverse transform stage
-#define SHIFT_INV_2ND         12 // Shift after second inverse transform stage
-
-extern Int g_quantScales[6];             // Q(QP%6)  
-extern Int g_invQuantScales[6];          // IQ(QP%6)
-extern const Short g_aiT4[4][4];
-extern const Short g_aiT8[8][8];
-extern const Short g_aiT16[16][16];
-extern const Short g_aiT32[32][32];
-
+extern const UInt g_auiPUOffset[NUMBER_OF_PART_SIZES];
+extern const Int g_quantScales[SCALING_LIST_REM_NUM];             // Q(QP%6)
+extern const Int g_invQuantScales[SCALING_LIST_REM_NUM];          // IQ(QP%6)
+#if RExt__HIGH_PRECISION_FORWARD_TRANSFORM
+static const Int g_transformMatrixShift[TRANSFORM_NUMBER_OF_DIRECTIONS] = { 14, 6 };
+#else
+static const Int g_transformMatrixShift[TRANSFORM_NUMBER_OF_DIRECTIONS] = {  6, 6 };
+#endif
+extern const TMatrixCoeff g_aiT4 [TRANSFORM_NUMBER_OF_DIRECTIONS][4][4];
+extern const TMatrixCoeff g_aiT8 [TRANSFORM_NUMBER_OF_DIRECTIONS][8][8];
+extern const TMatrixCoeff g_aiT16[TRANSFORM_NUMBER_OF_DIRECTIONS][16][16];
+extern const TMatrixCoeff g_aiT32[TRANSFORM_NUMBER_OF_DIRECTIONS][32][32];
 // ====================================================================================================================
 // Luma QP to Chroma QP mapping
 // ====================================================================================================================
-
-extern const UChar  g_aucChromaScale      [58];
-
+static const Int chromaQPMappingTableSize = 58;
+extern const UChar  g_aucChromaScale[NUM_CHROMA_FORMAT][chromaQPMappingTableSize];
 // ====================================================================================================================
 // Scanning order & context mapping table
 // ====================================================================================================================
-
-extern       UInt*  g_auiSigLastScan[ 3 ][ MAX_CU_DEPTH ];  // raster index from scanning index (diag, hor, ver)
-
-extern const UInt   g_uiGroupIdx[ 32 ];
-extern const UInt   g_uiMinInGroup[ 10 ];
-
-extern const UInt   g_sigLastScan8x8[ 3 ][ 4 ];           //!< coefficient group scan order for 8x8 TUs
-extern       UInt   g_sigLastScanCG32x32[ 64 ];
-
-// ====================================================================================================================
-// ADI table
-// ====================================================================================================================
-
-extern const UChar  g_aucIntraModeNumFast[ MAX_CU_DEPTH ];
-
-// ====================================================================================================================
-// Bit-depth
-// ====================================================================================================================
-
-extern        Int g_bitDepthY;
-extern        Int g_bitDepthC;
-extern       UInt g_uiPCMBitDepthLuma;
-extern       UInt g_uiPCMBitDepthChroma;
-
-// ====================================================================================================================
-// Texture type to integer mapping
-// ====================================================================================================================
-
-extern const UChar g_aucConvertTxtTypeToIdx[4];
-
+extern const UInt   ctxIndMap4x4[4*4];
+extern const UInt   g_uiGroupIdx[ MAX_TU_SIZE ];
+extern const UInt   g_uiMinInGroup[ LAST_SIGNIFICANT_GROUPS ];
+// ====================================================================================================================
+// Intra prediction table
+// ====================================================================================================================
+extern const UChar  g_aucIntraModeNumFast_UseMPM[MAX_CU_DEPTH];
+extern const UChar  g_aucIntraModeNumFast_NotUseMPM[MAX_CU_DEPTH];
+extern const UChar  g_chroma422IntraAngleMappingTable[NUM_INTRA_MODE];
 #if H_3D_DIM
 // ====================================================================================================================
@@ -156,20 +97,15 @@
 __inline Void mapDepthModeToIntraDir( UInt& intraMode ) { if( isDimMode( intraMode ) ) intraMode = DC_IDX; }
 __inline Void mapDepthModeToIntraDir(  Int& intraMode ) { if( isDimMode( intraMode ) ) intraMode = DC_IDX; }
-
 #if H_3D_DIM_SDC || H_3D_DIM_DLT
 __inline UInt numBitsForValue( UInt value ) { UInt bits = 0; while (value != 0) { value >>= 1; bits++; } return bits; };
 #endif
-
 #if H_3D_DIM_DMM
 extern const WedgeResolution                                 g_dmmWedgeResolution [6];
 extern const UChar                                           g_dmm1TabIdxBits     [6];
 extern const UChar                                           g_dmm3IntraTabIdxBits[6];
-
 extern Bool                                                  g_wedgePattern[32*32];
-
 extern       std::vector< std::vector<TComWedgelet> >        g_dmmWedgeLists;
 extern       std::vector< std::vector<TComWedgeRef> >        g_dmmWedgeRefLists;
 extern       std::vector< std::vector<TComWedgeNode> >       g_dmmWedgeNodeLists;
-
 Void initWedgeLists( Bool initNodeList = false );
 Void createWedgeList( UInt uiWidth, UInt uiHeight, std::vector<TComWedgelet> &racWedgeList, std::vector<TComWedgeRef> &racWedgeRefList, WedgeResolution eWedgeRes );
@@ -177,12 +113,8 @@
 #endif
 #endif
-
-// ==========================================
+// ====================================================================================================================
 // Mode-Dependent DST Matrices
-extern const Short g_as_DST_MAT_4 [4][4];
-extern const UChar g_aucDCTDSTMode_Vert[NUM_INTRA_MODE];
-extern const UChar g_aucDCTDSTMode_Hor[NUM_INTRA_MODE];
-// ==========================================
-
+// ====================================================================================================================
+extern const TMatrixCoeff g_as_DST_MAT_4 [TRANSFORM_NUMBER_OF_DIRECTIONS][4][4];
 #if H_MV_HLS_PTL_LIMITS
 class TComGeneralTierAndLevelLimits
@@ -203,5 +135,4 @@
     m_maxTileCols               ( maxTileCols                   );
   {};
-
   Int getMaxLumaPs                 ( ) { return m_maxLumaPs                 ; };
   Int getMaxCPBMainTier            ( ) { return m_maxCPBMainTier            ; };
@@ -210,5 +141,4 @@
   Int getMaxTileRows               ( ) { return m_maxTileRows               ; };
   Int getMaxTileCols               ( ) { return m_maxTileCols               ; };
-
 private:
   const Int m_maxLumaPs;
@@ -219,18 +149,16 @@
   const Int m_maxTileCols; 
 };
-
 extern std::map< Level::Name, TComGeneralTierAndLevelLimits > g_generalTierAndLevelLimits;   
-
 #endif
 // ====================================================================================================================
 // Misc.
 // ====================================================================================================================
-
 extern       Char   g_aucConvertToBit  [ MAX_CU_SIZE+1 ];   // from width to log2(width)-2
-
+#if NH_MV
+// Change later
 #ifndef ENC_DEC_TRACE
-#define ENC_DEC_TRACE   0  
-#endif
-
+#define ENC_DEC_TRACE 0
+#endif
+#endif
 #if ENC_DEC_TRACE
 extern FILE*  g_hTrace;
@@ -240,8 +168,6 @@
 extern Bool   g_HLSTraceEnable;
 extern UInt64 g_nSymbolCounter;
-
 #define COUNTER_START    1
 #define COUNTER_END      0 //( UInt64(1) << 63 )
-
 #define DTRACE_CABAC_F(x)     if ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) fprintf( g_hTrace, "%f", x );
 #define DTRACE_CABAC_V(x)     if ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) fprintf( g_hTrace, "%d", x );
@@ -251,8 +177,7 @@
 #define DTRACE_CABAC_R( x,y ) if ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) fprintf( g_hTrace, x,    y );
 #define DTRACE_CABAC_N        if ( ( g_nSymbolCounter >= COUNTER_START && g_nSymbolCounter <= COUNTER_END )|| g_bJustDoIt ) fprintf( g_hTrace, "\n"    );
-
 #if H_MV_ENC_DEC_TRAC
  extern Bool   g_traceCU; 
- extern Bool   g_tracePU; 
+ extern Bool   g_tracePU ; 
  extern Bool   g_traceTU; 
  extern Bool   g_disableHLSTrace;       // USE g_HLSTraceEnable to toggle HLS trace. Not this one!
@@ -267,5 +192,4 @@
  extern Bool   g_traceCameraParameters; // Trace camera parameters
  extern Bool   g_encNumberOfWrittenBits;// Trace number of written bits
-
 #define DTRACE_CU(x,y)             writeToTraceFile( x,y, g_traceCU );
 #define DTRACE_PU(x,y)             writeToTraceFile( x,y, g_tracePU );
@@ -274,11 +198,10 @@
 #define DTRACE_PU_S(x)             writeToTraceFile( x,   g_tracePU );
 #define DTRACE_TU_S(x)             writeToTraceFile( x,   g_traceTU );
-
+ Void           tracePSHeader   ( const Char* psName, Int layerId ); 
  Void           writeToTraceFile( const Char* symbolName, Int val, Bool doIt );
  Void           writeToTraceFile( const Char* symbolName, Bool doIt );
- Void           stopAtPos       ( Int poc, Int layerId, Int cuPelX, Int cuPelY, Int cuWidth, Int cuHeight );
+ Void           stopAtPos       ( Int poc, Int layerId, Int cuPelX, Int cuPelY, Int cuWidth, Int cuHeight );           
 #endif
 #else
-
 #define DTRACE_CABAC_F(x)
 #define DTRACE_CABAC_V(x)
@@ -288,96 +211,21 @@
 #define DTRACE_CABAC_R( x,y )
 #define DTRACE_CABAC_N
-
 #if H_MV_ENC_DEC_TRAC
 #define DTRACE_CU(x,y) ;             
 #define DTRACE_PU(x,y) ;            
 #define DTRACE_TU(x,y) ;            
-
 #define DTRACE_CU_S(x) ;            
 #define DTRACE_PU_S(x) ;            
 #define DTRACE_TU_S(x) ;            
-
-#endif
-#endif
-
-
-#define SCALING_LIST_NUM 6         ///< list number for quantization matrix
-#define SCALING_LIST_NUM_32x32 2   ///< list number for quantization matrix 32x32
-#define SCALING_LIST_REM_NUM 6     ///< remainder of QP/6
-#define SCALING_LIST_START_VALUE 8 ///< start value for dpcm mode
-#define MAX_MATRIX_COEF_NUM 64     ///< max coefficient number for quantization matrix
-#define MAX_MATRIX_SIZE_NUM 8      ///< max size number for quantization matrix
-#define SCALING_LIST_DC 16         ///< default DC value
-enum ScalingListSize
-{
-  SCALING_LIST_4x4 = 0,
-  SCALING_LIST_8x8,
-  SCALING_LIST_16x16,
-  SCALING_LIST_32x32,
-  SCALING_LIST_SIZE_NUM
-};
-static const Char MatrixType[4][6][20] =
-{
-  {
-  "INTRA4X4_LUMA",
-  "INTRA4X4_CHROMAU",
-  "INTRA4X4_CHROMAV",
-  "INTER4X4_LUMA",
-  "INTER4X4_CHROMAU",
-  "INTER4X4_CHROMAV"
-  },
-  {
-  "INTRA8X8_LUMA",
-  "INTRA8X8_CHROMAU", 
-  "INTRA8X8_CHROMAV", 
-  "INTER8X8_LUMA",
-  "INTER8X8_CHROMAU", 
-  "INTER8X8_CHROMAV"  
-  },
-  {
-  "INTRA16X16_LUMA",
-  "INTRA16X16_CHROMAU", 
-  "INTRA16X16_CHROMAV", 
-  "INTER16X16_LUMA",
-  "INTER16X16_CHROMAU", 
-  "INTER16X16_CHROMAV"  
-  },
-  {
-  "INTRA32X32_LUMA",
-  "INTER32X32_LUMA",
-  },
-};
-static const Char MatrixType_DC[4][12][22] =
-{
-  {
-  },
-  {
-  },
-  {
-  "INTRA16X16_LUMA_DC",
-  "INTRA16X16_CHROMAU_DC", 
-  "INTRA16X16_CHROMAV_DC", 
-  "INTER16X16_LUMA_DC",
-  "INTER16X16_CHROMAU_DC", 
-  "INTER16X16_CHROMAV_DC"  
-  },
-  {
-  "INTRA32X32_LUMA_DC",
-  "INTER32X32_LUMA_DC",
-  },
-};
-extern Int g_quantIntraDefault8x8[64];
-extern Int g_quantIntraDefault16x16[256];
-extern Int g_quantIntraDefault32x32[1024];
-extern Int g_quantInterDefault8x8[64];
-extern Int g_quantInterDefault16x16[256];
-extern Int g_quantInterDefault32x32[1024];
-extern Int g_quantTSDefault4x4[16];
-extern UInt g_scalingListSize [SCALING_LIST_SIZE_NUM];
-extern UInt g_scalingListSizeX[SCALING_LIST_SIZE_NUM];
-extern UInt g_scalingListNum  [SCALING_LIST_SIZE_NUM];
-extern Int  g_eTTable[4];
+#endif
+#endif
+const Char* nalUnitTypeToString(NalUnitType type);
+extern const Char *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
+extern const Char *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
+extern const Int g_quantTSDefault4x4[4*4];
+extern const Int g_quantIntraDefault8x8[8*8];
+extern const Int g_quantInterDefault8x8[8*8];
+extern const UInt g_scalingListSize [SCALING_LIST_SIZE_NUM];
+extern const UInt g_scalingListSizeX[SCALING_LIST_SIZE_NUM];
 //! \}
-
 #endif  //__TCOMROM__
-
